(

local elman = maxOps.GetRenderElementMgr #Production
local storedElements	
local maskElement
local workingGid = 128

struct elementsSettings (
	enabled, 
	elementsActive=#(),
	on create do (		
		enabled = elman.GetElementsActive() 
		elman.setElementsActive true
		for i = 0 to (elman.NumRenderElements()-1) do 
			(
			el = elman.GetRenderElement i
			append elementsActive el.enabled
			el.enabled = false
			)
		),
	fn restore = (
		for i = 1 to (elman.NumRenderElements()-1) do (elman.GetRenderElement (i-1)).enabled = elementsActive[i]
		elman.SetElementsActive enabled	
		)		
	)
	
fn AddMaskElement gid= (
	maskElement = CShading_Albedo elementname:"albedo"
	--maskElement.objectMono = gid
	--maskElement.objectMonoOn = true
	elman.addrenderelement maskelement	
	)

fn removeMaskElement = (
	elman.removerenderelement maskelement	
	)

fn storeElements = (	
	storedElements = elementsSettings()
	)

fn restoreElements = (
	storedElements.restore()	
	)
	
fn renderMask = (
			rsd = renderSceneDialog.isOpen()
			renderSceneDialog.close()
			storeElements()	
			AddMaskElement workingGid
			timelimit = renderers.current.progressive_timeLimit
			passlimit = renderers.current.progressive_passLimit
			giaa = renderers.current.shading_giToAaRatio
			renderers.current.progressive_timeLimit = 0
			renderers.current.progressive_passLimit = 6
			renderers.current.shading_giToAaRatio = 1
			rstate = renderers.current.shading_onlyElements
			renderers.current.shading_onlyElements = true
			max quick render
			renderers.current.shading_onlyElements = rstate
			renderers.current.progressive_timeLimit = timelimit
			renderers.current.progressive_passLimit = passlimit
			renderers.current.shading_giToAaRatio = giaa
			if rsd then renderSceneDialog.open()
			--CoronaRenderer.CoronaFp.showvfb()
			CoronaRenderer.CoronaFp.setDisplayedChannel 2
			restoreElements()	
			removeMaskElement()
					)	
on execute do renderMask()

	
)