(
try (cui.UnRegisterDialogBar Corona_tweaker) catch()
try (cui.FloatDialogBar Corona_tweaker) catch()
try (destroydialog Corona_tweaker) catch()

rollout Corona_tweaker "Corona Toolbar:" width:118 height:1000
(
	-- MATERIALS --
	label 'lbl1' "MATERIALS  setup:" pos:[3,1] width:91 height:14 align:#left
	
	spinner 'tbs' "" pos:[3,18] width:48 height:16 range:[0.01,1,1] align:#left
	button 'tbsb' "Bitmaps Blur" pos:[56,18] width:63 height:16 align:#left
	on tbsb pressed do
	(
	for mp in getClassInstances Bitmaptexture do 
			( 	mp.coords.blur = tbs.value )
	for mpc in getClassInstances CoronaBitmap do 
			( 	mpc.filteringBlur = tbs.value  )
	)
	
	spinner 'dll' "" pos:[13,38] width:38 height:16 range:[0.1,1,1] align:#left 
	button 'dll1' "1" pos:[2,37] width:12 height:18 align:#left
	on dll1 pressed do
			for i in getclassinstances coronamtl do
			( i.leveldiffuse = 1)
	button 'dllb' "Limit Diffuse" pos:[56,38] width:63 height:16 align:#left
	on dllb pressed do
			for i in getclassinstances coronamtl do
			( if i.leveldiffuse > dll.value then i.leveldiffuse = dll.value)
	
	button 'BatchMaterialEditor' "BatchMatEd" pos:[1,58] width:65 height:17 align:#left
	on BatchMaterialEditor pressed do
		(
			srchDir = GetDir #scripts
			scripts = getfiles (srchDir + "\\CoronaRenderer\\" + "NS_BatchMtlEditor_*.ms")
			
			if scripts.count != 0 then(
				sort scripts
				latest = scripts[scripts.count]
				filein latest
			)
			else(
				messageBox @"No NS_BatchMtlEditor script file found in Scripts\CoronaRenderer directory" title:"Error" 
			)
		)

	button 'btnResetMtlEdit' "cleanME" pos:[69,58] width:50 height:17 align:#left
	on btnResetMtlEdit pressed do
		try (
			(   for i = 1 to 24 do  
			(meditMaterials[i] = CoronaMtl name:("CoronaMtl - " + (formattedPrint i format:".2d"))	)
			--for i in getclassinstances coronamtl do
			--( 	i.leveldiffuse=0.8; i.colordiffuse=color 220 220 220  )					
			)
			) catch()
		
	checkButton 'ShowHideMaps' "ShowMaps" pos:[1,77] width:65 height:16 enabled:true align:#left
	on ShowHideMaps changed state do
		( 	if state == on then (for i in getclassinstances CoronaMtl do
					try (showTextureMap i i.texmapDiffuse on) catch())
			else (for i in getclassinstances CoronaMtl do
					try (showTextureMap i i.texmapDiffuse off) catch()) 	
		)			
			
	button 'SceneMaterials2MaterialEditor' "SM2ME" pos:[69,77] width:50 height:16 align:#left
	on SceneMaterials2MaterialEditor pressed do
	(
	i=0
	while i< 24 do(
		i=i+1
		meditMaterials[i]=CoronaMtl name:("CoronaMtl - " + (formattedPrint i format:".2d"))	
		--for i in getclassinstances coronamtl do
		--( 	i.leveldiffuse=0.8; i.colordiffuse=color 220 220 220  )
	)

	i=0
	numberOfMaterials = sceneMaterials.count
	if numberOfMaterials > 24 then numberOfMaterials = 24

	while i< numberOfMaterials do(
		i=i+1
		meditMaterials[i]=sceneMaterials[i]
	)
)
		
	button 'CConverter' "Corona Converter" pos:[1,96] width:118 height:40 align:#left
	on CConverter pressed do
			(
			srchDir = GetDir #scripts
			scripts = getfiles (srchDir + "\\CoronaRenderer\\" + "CoronaConverter_v*.ms")
			
			if scripts.count != 0 then(
				sort scripts
				latest = scripts[scripts.count]
				filein latest
			)
			else(
				messageBox @"No CoronaConverter script file found in Scripts\CoronaRenderer directory" title:"Error" 
			)
		)
	
		
	
	-- LIGHTS --	
		
	label 'lbl211' "LIGHTING  setup:" pos:[3,144] width:84 height:14 align:#left
	button 'CLL' "Corona light lister" pos:[1,161] width:118 height:16 align:#left
	on CLL pressed do
			(filein "$scripts\CoronaRenderer\GTools_lightlister.ms")
	
	button 'CIes' "Corona IES library" pos:[1,180] width:118 height:16 align:#left
	on CIes pressed do
			(filein "$scripts\CoronaRenderer\CoronaIesPresets v1.02.ms")
	
	-- FRAMEBUFFER --
	
	label 'lbl3' "FRAMEBUFFER setup:" pos:[3,204] width:108 height:14 align:#left
	checkButton 'ShowCrnVfb' "Corona VFB" pos:[1,220] width:118 height:40 enabled:true align:#left
	on ShowCrnVfb changed state do
		(	if state == on then CoronaRenderer.CoronaFp.showVfb true
			else CoronaRenderer.CoronaFp.showVfb false 	)
	
	label 'lbl4' "VFB Gamma" pos:[3,265] width:56 height:14 align:#left
	spinner 'gamma' "" pos:[80,264] width:39 height:16 range:[-3.0,3.0,2.2+renderers.current.colormap_additionalGamma] align:#left
	on gamma changed val do try 
			(
				renderers.current.colormap_additionalGamma = gamma.value - 2.2
			) catch()
	
			
			
	-- RENDER --	
			
	local currenth = (renderers.current.progressive_timeLimit/3600000)
	local currentm = (renderers.current.progressive_timeLimit*60/3600000 - renderers.current.progressive_timeLimit/3600000*60)
			
	label 'lbl5' "RENDER setup:" pos:[3,290] width:74 height:14 align:#left
	label 'Time_hrs' "hrs" pos:[3,307] width:16 height:14 align:#left
	spinner 'TimeLimH' "" pos:[21,307] width:34 height:16 range:[0,99,TimeLimH.value = renderers.current.progressive_timeLimit/3600000] align:#left type:#integer
	label 'Time_mins' "mins" pos:[57,307] width:21 height:14 align:#left
	spinner 'TimeLimM' "" pos:[80,307] width:39 height:16 range:[0,59,TimeLimM.value = (renderers.current.progressive_timeLimit - TimeLimH.value*3600000)/60000] align:#left type:#integer
	on TimeLimH changed val do try ( 
			(renderers.current.progressive_timeLimit = 3600000*TimeLimH.value+60000*TimeLimM.value)
			) catch()
			
	on TimeLimM changed val2 do try ( 
			(renderers.current.progressive_timeLimit = 3600000*TimeLimH.value+60000*TimeLimM.value)
			) catch()
			
	label 'lbl8' "Target noise:" pos:[3,327] width:63 height:14 align:#left
	spinner 'nls' "" pos:[80,327] width:39 height:16 range:[1,15,2] align:#left type:#integer
	on nls changed val do try 
		(
			renderers.current.adaptivity_targetError = nls.value
			
		) catch()
			
	label 'lbl9' "Limit passes:" pos:[3,347] width:63 height:14 align:#left
	spinner 'passlim' "" pos:[80,347] width:39 height:16 range:[0,999,renderers.current.progressive_passLimit] align:#left type:#integer
	on passlim changed val do
		try ( (renderers.current.progressive_passLimit = passlim.value) ) catch()
		
	/*label 'GIAAl' "GI/AA balance" pos:[3,367] width:69 height:14 align:#left
	spinner 'giaa' "" pos:[80,367] width:39 height:16 range:[2,64,renderers.current.shading_giToAaRatio] align:#left type:#integer
	on giaa changed val do
		try ( (renderers.current.shading_giToAaRatio = giaa.value) ) catch()
	*/
	checkbox 'Mtl_override' "    Mtl.override" pos:[2,369] width:100 height:16 align:#left checked:renderers.current.mtlOverride_enabled
	on Mtl_override changed state do try (
		( 	renderers.current.mtlOverride_enabled = state
		 	)	) catch()
	
	checkbox 'Displacecb' "    Displacement" pos:[2,386] width:100 height:16 align:#left checked:renderDisplacements
	on Displacecb changed state do try (
		( 	renderDisplacements = state
		renderSceneDialog.update() 	)	) catch()
		
	checkbox 'Denoiser' "    Denoise image" pos:[2,403] width:100 height:16 align:#left checked:false
	on Denoiser changed state do try 
		(
		 	case Denoiser.state of 
			(
			true: renderers.current.denoise_filterType = 2
			false: renderers.current.denoise_filterType = 0
			)	
		) 
		catch()	
		
	button 'Renderrun' "Render (F9)" checked:false pos:[1,424] width:118 height:40 align:#left
	on Renderrun pressed do 
		(CoronaRenderer.CoronaFp.setDisplayedChannel 0	
		( max quick render ))
	
	button 'startIR' "Start interactive" pos:[1,466] width:118 height:40 align:#left
	on startIR pressed do try (
		( CoronaRenderer.CoronaFp.setDisplayedChannel 0 
			CoronaRenderer.CoronaFp.startInteractive() ) ) catch()
			
	button 'rlrb' "Resume render" pos:[1,508] width:118 height:20 align:#left
	on rlrb pressed do
		( CoronaRenderer.CoronaFp.setDisplayedChannel 0
			coronarenderer.resumeRender() )		
			
	button 'RenderElements' "Render only elements" pos:[1,530] width:118 height:20 align:#left	
	on RenderElements pressed do try (
		rstate = renderers.current.shading_onlyElements
		renderers.current.shading_onlyElements = true
		(max quick render) 
		renderers.current.shading_onlyElements = rstate) catch()
			
	checkButton 'Renderview' "Region render On/Off" pos:[1,552] width:118 height:20 align:#left
	on Renderview changed state do
		( 	if state == on then 
					( setRenderType #region; EditRenderRegion.EditRegion() )
			else 	( EditRenderRegion.EditRegion() false; setRenderType #view )
		)
			
	button 'rs' "Render Selection" pos:[1,574] width:118 height:20 align:#left
	on rs pressed do
		(
		r=renderers.current.renderSelected_mode as integer
		renderers.current.renderSelected_mode=1
		CoronaRenderer.CoronaFp.setDisplayedChannel 0
		max quick render
		renderers.current.renderSelected_mode=r
		)	
		
	button 'RSmask' "Render Selection Mask" pos:[1,596] width:118 height:20 align:#left
	on RSmask pressed do
			(filein "$scripts\CoronaRenderer\corona-quickMask.ms")
		
	button 'btnAlbedo' "Albedo test render" pos:[1,618] width:118 height:20 align:#left
	on btnAlbedo pressed do
		(filein "$scripts\CoronaRenderer\corona-quickAlbedo2.ms")
	
	button 'ascrb' "Assign Corona Render" pos:[1,653] width:118 height:20 align:#left
	on ascrb pressed do 
		(
			renderpresets.SaveAll 0 (GetDir #renderPresets + "\\PreviousRndrStngs.rps");
			renderers.production = CoronaRenderer() 
		)
	
	button 'rsb' "Reset Corona" pos:[1,675] width:118 height:20 align:#left
	on rsb pressed do 
		(
			renderpresets.SaveAll 0 (GetDir #renderPresets + "\\coronareset.rps");
			renderers.production = Default_Scanline_Renderer();
			renderers.production = CoronaRenderer(); 
			renderpresets.LoadAll 0 (GetDir #renderPresets + "\\coronareset.rps")
		)
	
	button 'OpenF10' "(F10) Render settings" pos:[1,697] width:118 height:20 align:#left
	on OpenF10 pressed do
		( if renderSceneDialog.isOpen()==true then renderSceneDialog.Close() 
			else renderSceneDialog.Open() 		)
	
	label 'lbl11' "======================" pos:[3,638] width:113 height:10 align:#left
	
	-- PROXY --	
	
	label 'lbl12' "PROXY tools/setup:" pos:[3,727] width:94 height:14 align:#left
	button 'CPL' "Corona Proxy lister" pos:[1,743] width:118 height:20 align:#left
	on CPL pressed do
			(fileIn "$scripts\CoronaRenderer\NS_CoronaProxyLister.ms")
	
	button 'V2CPConverter' "VRay > Corona Proxy" pos:[1,765] width:118 height:20 align:#left
	on V2CPConverter pressed do
			(filein "$scripts\CoronaRenderer\coronaConvertProxies.ms")
	
	button 'V2CSConverter' "VRay > Corona scatter" pos:[1,787] width:118 height:20 align:#left
	on V2CSConverter pressed do
			(filein "$scripts\CoronaRenderer\coronaScatterConverter_v0.03.ms")
	
	
	-- UTILITIES --
	
	label 'lbl13' "CORONA utilities:" pos:[3,816] width:84 height:14 align:#left
	button 'Panarama_Exporter' "Panarama exporter" pos:[1,855] width:118 height:20 align:#left
	on Panarama_Exporter pressed do
		(filein "$scripts\CoronaRenderer\PanoramaExporter_v0.3.ms")
	
	button 'CVR' "Corona VR tools" pos:[1,833] width:118 height:20 align:#left
	on CVR pressed do
			(fileIn "$scripts\CoronaRenderer\CoronaVR.ms")

/*
-	Ensure your camera is completely horizontal

- Add CoronaCamera Mod

- Enable Projection Type Override, leave at default Spherical

- Enable Spherical VR mod, leave at defaults

- Ensure camera is placed so that no objects are closer than 0.5m / 500mm to avoid the "cross eyed" effect

- Under Render Setup, Common, set Output Size to Custom, and set Image Aspect to 1 and lock it

- Recommended resolution is 4000 for testing, higher may be used for final renders */
	
	-- CONTACTS --
	
	label 'lbl14' "Corona toolbar v1.5.1" pos:[3,889] width:113 height:14 align:#left
	label 'lbl15' "======================" pos:[1,877] width:118 height:10 align:#left
	label 'lbl16' "Created by  headoff" pos:[3,905] width:113 height:12 align:#left
	label 'lbl17' "archdizs@gmail.com" pos:[3,919] width:113 height:14 align:#left
	label 'lbl18' "Updated by  vansan" pos:[3,934] width:113 height:14 align:#left
	label 'lbl20' "info@sidis.biz" pos:[3,950] width:113 height:14 align:#left
)

clearSelection()
createdialog Corona_tweaker pos:[0,150] width:120
cui.RegisterDialogBar Corona_tweaker style:#(#cui_dock_left, #cui_dock_right, #cui_floatable, #cui_handles)
cui.DockDialogBar Corona_tweaker #cui_dock_left
)